class DoublyLinkedList {
     Cell first, last;

    //LinkList constructor
    public DoublyLinkedList() {
            first = null;
            last = null;
    }

    //Returns true if list is empty
    public boolean isEmpty() {
            return first == null;
    }

    //Inserts a new Cell at the end of the list
    public void insert(int d) {
         Cell cell = new Cell(d);
        if(!isEmpty()){
            cell.setPrevCell(last);
            last.setNextCell(cell);
            last = cell;
        }
        else{
              first=cell;
              last=cell;
            }
    }

    //Deletes the cell at the first of the list
    public Cell delete() {
            Cell temp = first;
            first = first.getNextCell();
            if (first != null) first.setPrevCell(null);
            return temp;
    }

    //Prints list data
    public void printList() {
            Cell currentCell = first;
            System.out.print("List: ");
            while(currentCell != null) {
                    currentCell.printCell();
                    currentCell = currentCell.getNextCell();
            }
            System.out.println("");
    }
    
    Iterator createForwardIterator(){
        Cell start = new Cell(0);
        start.setNextCell(first);
        Iterator forwardI= new ForwardIterator(start);
        return forwardI;
    }

        
    Iterator createBackIterator(){
         Cell start = new Cell(0);
        start.setPrevCell(last);
        Iterator backI= new BackIterator(start);
        return backI;
    }
}  

